Package org.sunflow.core.light

## Class TriangleMeshLight

- java.lang.Object
- - org.sunflow.core.primitive.TriangleMesh
  - - org.sunflow.core.light.TriangleMeshLight

- All Implemented Interfaces:
    `LightSource`, `PrimitiveList`, `RenderObject`, `Shader`

      public class TriangleMeshLight
      extends TriangleMesh
      implements Shader, LightSource

- - ### Field Summary

    - ### Fields inherited from class org.sunflow.core.primitive.TriangleMesh

      `points, triangles`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TriangleMeshLight()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Instance` | `createInstance()` | Create an instance which represents the geometry of this light source.
    `int` | `getNumSamples()` | Get the maximum number of samples that can be taken from this light source.
    `Color` | `getOpacity​(ShadingState state)` | Returns how much light is blocked by this shader.
    `void` | `getPhoton​(double randX1, double randY1, double randX2, double randY2, Point3 p, Vector3 dir, Color power)` | Gets a photon to emit from this light source by setting each of the arguments.
    `float` | `getPower()` | Get the total power emitted by this light source.
    `Color` | `getRadiance​(ShadingState state)` | Gets the radiance for a specified rendering state.
    `void` | `getSamples​(ShadingState state)` | Samples the light source to compute direct illumination.
    `boolean` | `isOpaque()` | Returns `true` if this shader is fully opaque.
    `void` | `scatterPhoton​(ShadingState state, Color power)` | Scatter a photon with the specied power.
    `boolean` | `update​(ParameterList pl, SunflowAPI api)` | Update this object given a list of parameters.

    - ### Methods inherited from class org.sunflow.core.primitive.TriangleMesh

      `getBakingPrimitives, getNumPrimitives, getPoint, getPoint, getPrimitiveBound, getWorldBounds, init, intersectPrimitive, prepareShadingState, setSmallTriangles, writeObj`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TriangleMeshLight

          public TriangleMeshLight()

  - ### Method Detail

    - #### update

          public boolean update​(ParameterList pl,
                                SunflowAPI api)

      Description copied from interface: `RenderObject`
      Update this object given a list of parameters. This method is guarenteed to be called at least once on every object, but it should correctly handle empty parameter lists. This means that the object should be in a valid state from the time it is constructed. This method should also return true or false depending on whether the update was succesfull or not.
      Specified by:
        `update` in interface `RenderObject`
      Overrides:
        `update` in class `TriangleMesh`
      Parameters:
        `pl` - list of parameters to read from
        `api` - reference to the current scene
      Returns:
        `true` if the update is succesfull, `false` otherwise

    - #### getRadiance

          public Color getRadiance​(ShadingState state)

      Description copied from interface: `Shader`
      Gets the radiance for a specified rendering state. When this method is called, you can assume that a hit has been registered in the state and that the hit surface information has been computed.
      Specified by:
        `getRadiance` in interface `Shader`
      Parameters:
        `state` - current render state
      Returns:
        color emitted or reflected by the shader

    - #### scatterPhoton

          public void scatterPhoton​(ShadingState state,
                                    Color power)

      Description copied from interface: `Shader`
      Scatter a photon with the specied power. Incoming photon direction is specified by the ray attached to the current render state. This method can safely do nothing if photon scattering is not supported or relevant for the shader type.
      Specified by:
        `scatterPhoton` in interface `Shader`
      Parameters:
        `state` - current state
        `power` - power of the incoming photon.

    - #### createInstance

          public Instance createInstance()

      Description copied from interface: `LightSource`
      Create an instance which represents the geometry of this light source. This instance will be created just before and removed immediately after rendering. Non-area light sources can return `null` to indicate that no geometry needs to be created.
      Specified by:
        `createInstance` in interface `LightSource`
      Returns:
        an instance describing the light source

    - #### getNumSamples

          public int getNumSamples()

      Description copied from interface: `LightSource`
      Get the maximum number of samples that can be taken from this light source. This is currently only used for statistics reporting.
      Specified by:
        `getNumSamples` in interface `LightSource`
      Returns:
        maximum number of samples to be taken from this light source

    - #### getPhoton

          public void getPhoton​(double randX1,
                                double randY1,
                                double randX2,
                                double randY2,
                                Point3 p,
                                Vector3 dir,
                                Color power)

      Description copied from interface: `LightSource`
      Gets a photon to emit from this light source by setting each of the arguments. The two sampling parameters are points on the unit square that can be used to sample a position and/or direction for the emitted photon.
      Specified by:
        `getPhoton` in interface `LightSource`
      Parameters:
        `randX1` - sampling parameter
        `randY1` - sampling parameter
        `randX2` - sampling parameter
        `randY2` - sampling parameter
        `p` - position to shoot the photon from
        `dir` - direction to shoot the photon in
        `power` - power of the photon

    - #### getPower

          public float getPower()

      Description copied from interface: `LightSource`
      Get the total power emitted by this light source. Lights that have 0 power will not emit any photons.
      Specified by:
        `getPower` in interface `LightSource`
      Returns:
        light source power

    - #### getSamples

          public void getSamples​(ShadingState state)

      Description copied from interface: `LightSource`
      Samples the light source to compute direct illumination. Light samples can be created using the `LightSample` class and added to the current `ShadingState`. This method is responsible for the shooting of shadow rays which allows for non-physical lights that don't cast shadows. It is recommended that only a single shadow ray be shot if `ShadingState.getDiffuseDepth()` is greater than 0. This avoids an exponential number of shadow rays from being traced.
      Specified by:
        `getSamples` in interface `LightSource`
      Parameters:
        `state` - current state, including point to be shaded
      See Also:
        `LightSample`

    - #### isOpaque

          public boolean isOpaque()

      Description copied from interface: `Shader`
      Returns `true` if this shader is fully opaque. This gives a quick way to find out if a shader needs further processing when hit by a shadow ray.
      Specified by:
        `isOpaque` in interface `Shader`

    - #### getOpacity

          public Color getOpacity​(ShadingState state)

      Description copied from interface: `Shader`
      Returns how much light is blocked by this shader.
      Specified by:
        `getOpacity` in interface `Shader`